%global commitId 6fb977e18a0eb00f57ed2a97ff7f4fbaf6fa7aa3

%global tower_version 4.4.5
%global tower_release 1
%global aap_version 2.4
%global controller_source_name automation-controller-%{commitId}
%global controller_assets_source_name controller-assets-055ca6fc16d166d739a6b395dd7fe357b9b5e207
%global tower_override_source_name tower-override-858b7c0ca2634c5c821e72b0083ced5715c50eaf
%global cryptography_source_name cryptography-41.0.3
%global cryptography_vendor_source_name cryptography-vendor-2f90cb85bfa5382d364777e0b076b27401474f4b
%global ansible_ui_source_name aap-ui-000f4fd10106d31e789dfadf0a4e8d69e250361f

%if 0%{?rhel} == 8
%global hardlink_pkg hardlink
%global hardlink_binary %{_sbindir}/hardlink
%global python3_pkgversion 39
%else
%global hardlink_pkg util-linux-core
%global hardlink_binary %{_bindir}/hardlink
%endif

%global distro_python_sitelib %(/usr/libexec/platform-python -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")

# Remove brp-python-bytecompile from os_install_post
%global __os_install_post /usr/lib/rpm/brp-compress \
  %{!?__debug_package:/usr/lib/rpm/brp-strip %{__strip}} \
  /usr/lib/rpm/brp-strip-static-archive %{__strip} \
  /usr/lib/rpm/brp-strip-comment-note %{__strip} %{__objdump} \
  /usr/lib/rpm/brp-python-hardlink

Name: automation-controller
Summary: REST api, server, plugins, UI, & CLI client for ansible
Version: %{tower_version}
Release: %{tower_release}%{?dist}
Source0: automation-controller-6fb977e18a0eb00f57ed2a97ff7f4fbaf6fa7aa3.tar.gz
Source1: aap-ui-000f4fd10106d31e789dfadf0a4e8d69e250361f.tar.gz
Source2: controller-assets-055ca6fc16d166d739a6b395dd7fe357b9b5e207.tar.gz
Source3: automation-controller.service
Source4: python_bundled_dep.txt
Source5: js_bundled_dep.txt
Source6: rsyslog.conf
Source7: tower-override-858b7c0ca2634c5c821e72b0083ced5715c50eaf.tar.gz
%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
Source8: cryptography-vendor-2f90cb85bfa5382d364777e0b076b27401474f4b.tar.gz
Source91: system-certifi-5aa52ab91f9d579bfe52b5acf30ca799f1a563d9.tar.gz
Source92: django-radius-218428c20e885a300774dfaccc67ef10b2e976aa.tar.gz
Source93: python3-saml-f90824c4910e36c5a89dd295271be26691204ba3.tar.gz
%endif
Provides: automation-controller = %{version}-%{release}
Obsoletes: ansible-tower <= %{version}-%{release}

License: Commercial, see https://www.redhat.com/en/about/red-hat-end-user-license-agreements and https://www.redhat.com/en/about/licenses
URL:     https://github.com/ansible/awx

# Build Requirements
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-pip
BuildRequires: python%{python3_pkgversion}-rpm-macros
BuildRequires: python%{python3_pkgversion}-setuptools
BuildRequires: python%{python3_pkgversion}-wheel

BuildRequires: %{hardlink_pkg}
BuildRequires: sed
BuildRequires: git-core
BuildRequires: make
BuildRequires: gcc-c++
BuildRequires: bzip2
BuildRequires: postgresql-devel
BuildRequires: libffi-devel
BuildRequires: openssl-devel
%if 0%{?rhel} == 8
BuildRequires: openldap-devel
%else
BuildRequires: openldap-devel >= 2.6.2
%endif
BuildRequires: libxml2-devel
BuildRequires: libxslt-devel
BuildRequires: xmlsec1-devel, xmlsec1-openssl-devel
BuildRequires: libtool-ltdl-devel
BuildRequires: swig
BuildRequires: libyaml-devel
BuildRequires: glibc-langpack-en
BuildRequires: cargo

BuildRequires: fontconfig
BuildRequires: gettext
BuildRequires: npm
BuildRequires: rsync

Requires: automation-controller-server = %{version}-%{release}
Requires: automation-controller-ui = %{version}-%{release}


%description
REST api, server, plugins, Web UI, & CLI client for ansible.

%package server
Summary: Automation Controller REST API
AutoReqProv: no
Obsoletes: ansible-tower-server <= %{version}-%{release}
Requires: automation-controller-venv-tower = %{version}-%{release}
Requires: ansible-automation-platform-common = %{aap_version}
Requires: nginx >= 1:1.18.0
Requires: crontabs
Requires: sshpass
Requires: supervisor >= 3.0
Requires: git-core
Requires: git-lfs
Requires: subscription-manager
Requires: subversion
Requires: postgresql
Requires: redis >= 6.0
Requires: sos
Requires: rsync
Requires: rsyslog >= 8.1911
Requires: xmlsec1
Requires: xmlsec1-openssl
Requires: crun
%if 0%{?rhel} == 8
Requires: openldap
%else
Requires: openldap >= 2.6.2
%endif

# SELinux requirements
Requires: python3-libsemanage
BuildArch: noarch

%description server
Automation Controller Server and REST API

%package ui
Summary: Automation Controller UI
Requires: automation-controller-server = %{version}-%{release}
Obsoletes: ansible-tower-ui <= %{version}-%{release}
BuildArch: noarch

%description ui
UI for Automation Controller

%package venv-tower
Summary: Automation Controller virtual environment
AutoReqProv: no
Obsoletes: ansible-tower-venv-ansible <= %{version}-%{release}
Obsoletes: ansible-tower-venv-tower <= %{version}-%{release}
Requires(pre): python%{python3_pkgversion}

# Python dependencies
%include %{SOURCE4}

# JS dependencies
%include %{SOURCE5}

%description venv-tower
Automation Controller virtual environment

%package cli
Summary: Package for Automation Controller CLI
AutoReqProv: no
Obsoletes: ansible-tower-cli <= %{version}-%{release}
Requires: python%{python3_pkgversion}-requests
Requires: python%{python3_pkgversion}-pyyaml
BuildArch: noarch

%description cli
Package for Automation Controller CLI

%prep
%setup -q -T -b 1 -n %{ansible_ui_source_name}
%setup -q -T -b 2 -n %{controller_assets_source_name}
%setup -q -T -b 7 -n %{tower_override_source_name}
%setup -q -T -b 8 -n %{cryptography_vendor_source_name}
%setup -q -n %{controller_source_name}

%build
# Disable debuginfo packages
%define _enable_debug_package 0
%define debug_package %{nil}

# TODO: can be changed to cp? check file attributes in tar
rsync -avz %{_builddir}/%{tower_override_source_name}/ .
rsync -avz %{_builddir}/%{controller_assets_source_name}/awx/ui/client/assets/ awx/ui/public/static/media/

echo %{version} > VERSION
echo %{version} > awxkit/VERSION

npm config set registry https://repository.engineering.redhat.com/nexus/repository/registry.npmjs.org/
npm config set strict-ssl false

%{__python3} -m pip config set global.index https://repository.engineering.redhat.com/nexus/repository/pypi.org/pypi
%{__python3} -m pip config set global.index_url https://repository.engineering.redhat.com/nexus/repository/pypi.org/simple
%{__python3} -m pip config set global.trusted-host repository.engineering.redhat.com

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
mkdir requirements/vendor
cp %{SOURCE91} %{SOURCE92} %{SOURCE93} requirements/vendor/

cat > requirements/requirements_local.txt<<EOF
./requirements/vendor/system-certifi-5aa52ab91f9d579bfe52b5acf30ca799f1a563d9.tar.gz
./requirements/vendor/django-radius-218428c20e885a300774dfaccc67ef10b2e976aa.tar.gz
./requirements/vendor/python3-saml-f90824c4910e36c5a89dd295271be26691204ba3.tar.gz
EOF

pip_version=`grep pip== requirements/requirements.txt |cut -d'=' -f3`
%{__python3} -m pip install --user pip==$pip_version

~/.local/bin/pip%{python3_version} download \
        --no-deps \
        --platform any \
        --requirement=requirements/requirements.txt \
        --dest=requirements/vendor \
        --exists-action=i | grep --line-buffered .

# Add rust crates vendor file to cryptography
tar -xf %{_builddir}/%{cryptography_vendor_source_name}/%{cryptography_source_name}-vendor.tar.bz2
gzip -d requirements/vendor/%{cryptography_source_name}.tar.gz
tar -rf requirements/vendor/%{cryptography_source_name}.tar %{cryptography_source_name}
gzip requirements/vendor/%{cryptography_source_name}.tar

%endif

make ui-release

export NODE_ENV=production
export UI_NEXT_LOCAL=%{_builddir}/%{ansible_ui_source_name}

export BRAND="Red Hat"
export PRODUCT="Ansible Automation Platform"
export VERSION=%{aap_version}

make ui-next

pushd awxkit
  %{__python3} setup.py sdist
  cp dist/awxkit-%{version}.tar.gz %{_builddir}/%{name}-cli-%{version}-%{release}.tar.gz
popd


%install

export LANG=en_US.UTF-8 LANGUAGE=en_US.en LC_ALL=en_US.UTF-8

mkdir -p %{buildroot}/var/lib/awx/rsyslog
mkdir -p %{buildroot}/var/lib/awx/rsyslog/conf.d
cp %{SOURCE6} %{buildroot}/var/lib/awx/rsyslog/rsyslog.conf

export PYTHON=python%{python3_version}

# Create folder for the virtualenvs
export VENV_BASE=venv
mkdir -p $VENV_BASE

# Fix m2crypto builds (details at http://pkgs.fedoraproject.org/cgit/m2crypto.git/tree/m2crypto.spec)
export SWIG_FEATURES="-cpperraswarn"

%if "%{packager}" == "Red Hat, Inc. <http://bugzilla.redhat.com/bugzilla>"
export PIP_OPTIONS="--find-links=requirements/vendor --no-index"

cat >> setup.cfg <<EOF
[easy_install]
index_url = ''
find_links = file://$PWD/requirements/vendor/
EOF

cat >> ~/.pydistutils.cfg <<EOF
[easy_install]
index_url = ''
find_links = file://$PWD/requirements/vendor/
EOF
%endif

# Install the awxkit package
%{__python3} -m pip install ../%{name}-cli-%{version}-%{release}.tar.gz --root %{buildroot} --no-deps

export CFLAGS="-DXMLSEC_NO_SIZE_T"
# Install the Tower venv and requirements
%{__make} requirements_awx

# TODO
rm -f awx/devonly.py

# Move site-packages to the buildroot
mkdir -p %{buildroot}/var/lib/awx/venv/awx/lib/python%{python3_version}
mv venv/awx/lib/python%{python3_version}/site-packages %{buildroot}/var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages

# Move bin files
mkdir -p %{buildroot}/var/lib/awx/venv/awx/bin
rm -f %{buildroot}/var/lib/awx/venv/awx/bin/pip*
cp -rp venv/awx/bin/pip* %{buildroot}/var/lib/awx/venv/awx/bin/
mv venv/awx/bin/uwsgi %{buildroot}/var/lib/awx/venv/awx/bin/uwsgi
mv venv/awx/bin/uwsgitop %{buildroot}/var/lib/awx/venv/awx/bin/uwsgitop
mv venv/awx/bin/daphne %{buildroot}/var/lib/awx/venv/awx/bin/daphne
mv venv/awx/bin/ansible-runner %{buildroot}/var/lib/awx/venv/awx/bin/ansible-runner
mv venv/awx/bin/receptorctl %{buildroot}/var/lib/awx/venv/awx/bin/receptorctl

# Install to the buildroot (non virtualenv)
mkdir -p %{buildroot}/rpm-tmp

%{__python3} -m pip install \
  --no-compile \
  --no-deps \
  --progress-bar off \
  --no-index \
  --no-cache-dir \
  --no-build-isolation \
  --no-warn-script-location \
  --root=%{buildroot}/rpm-tmp \
  .

# Move files from rpm-tmp folder to the appropriate base folders
mv %{buildroot}/rpm-tmp/usr/lib/python%{python3_version}/site-packages/* %{buildroot}/var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages

mkdir -p %{buildroot}/usr/bin
mv %{buildroot}/rpm-tmp/usr/bin/awx-manage %{buildroot}/usr/bin
mv tools/scripts/automation-controller-service tools/scripts/failure-event-handler tools/scripts/awx-python %{buildroot}/usr/bin

# Replace python interpreter shebang to known destination system paths
PYTHON_INTERPRETER='#!/var/lib/awx/venv/awx/bin/python'
for executable in  %{buildroot}/usr/bin/awx-manage \
  %{buildroot}/var/lib/awx/venv/awx/bin/pip* \
  %{buildroot}/var/lib/awx/venv/awx/bin/daphne \
  %{buildroot}/var/lib/awx/venv/awx/bin/ansible-runner \
  %{buildroot}/var/lib/awx/venv/awx/bin/receptorctl
do
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" $executable
done

# Symlinks to old tower-python and tower-manage executables
ln -s /usr/bin/awx-manage %{buildroot}/%{_bindir}/tower-manage
ln -s /usr/bin/awx-python %{buildroot}/%{_bindir}/tower-python

mkdir -p %{buildroot}/usr/share/sosreport/sos/plugins
mv tools/sosreport/controller.py %{buildroot}/usr/share/sosreport/sos/plugins

mkdir -p %{buildroot}/usr/share/doc/%{name}
mv licenses/* %{buildroot}/usr/share/doc/%{name}

mkdir -p %{buildroot}/lib/systemd/system
install -m 644 %{SOURCE3} %{buildroot}/lib/systemd/system

mkdir -p %{buildroot}/usr/share/awx
mv tools/scripts/request_tower_configuration.sh tools/scripts/request_tower_configuration.ps1 %{buildroot}/usr/share/awx

rm -rf %{buildroot}/rpm-tmp

# Create other needed folders
install -d %{buildroot}/%{_sysconfdir}/tower/
install -d -m 0750 %{buildroot}/var/log/tower
install -d -m 0750 %{buildroot}/var/lib/awx/job_status
install -d %{buildroot}/%{_datadir}/awx
install -d -m 2775 %{buildroot}/var/run/tower

%clean
rm -rf %{buildroot}

%preun
automation-controller-service stop

%pre server
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
# Remove old links
rm -f %{distro_python_sitelib}/sos/plugins/tower.py >/dev/null 2>&1 || :
rm -f %{distro_python_sitelib}/sos/report/plugins/tower.py >/dev/null 2>&1 || :

%post server
# Generate or reuse key file
if [ ! -f /etc/tower/SECRET_KEY ]; then
%{__python3} -c 'import base64, os; f = open("/etc/tower/SECRET_KEY", "w"); f.write(base64.encodebytes(os.urandom(33)).decode().rstrip()); f.close()'
fi
chown root:awx /etc/tower/SECRET_KEY
chmod 640 /etc/tower/SECRET_KEY

# Create sosreport symlinks
ln -s /usr/share/sosreport/sos/plugins/controller.py  %{distro_python_sitelib}/sos/plugins/ || :
ln -s /usr/share/sosreport/sos/plugins/controller.py  %{distro_python_sitelib}/sos/report/plugins/ || :

# allow needed nginx access
/sbin/restorecon -R /var/lib/awx/venv /var/lib/awx/job_status /var/run/tower
chown -R nginx:nginx /var/run/tower || :
if [ $1 -eq 1 ] ; then
        # Initial installation
        systemctl --no-reload preset automation-controller.service >/dev/null 2>&1 || :
fi

%preun server
if [ $1 -eq 0 ] ; then
        # Package removal, not upgrade
        systemctl --no-reload disable --now automation-controller.service >/dev/null 2>&1 || :
fi

%postun server
sed -i -e '/^# START AWX/,/^# END AWX/d' /etc/supervisord.conf
# Remove custom policy
if [ $1 -eq 0 ] ; then
    # Remove sosreport symlinks
    rm -f %{distro_python_sitelib}/sos/plugins/controller.py || :
    rm -f %{distro_python_sitelib}/sos/report/plugins/controller.py || :
fi

%pre venv-tower
systemctl stop supervisord >/dev/null 2>&1 || :
getent group awx >/dev/null || groupadd -r awx
getent passwd awx >/dev/null || \
    useradd -r -g awx -d /var/lib/awx -s /bin/bash awx
%{__python3} -m venv --clear /var/lib/awx/venv/awx

%files
%defattr(-,root,root)

%files server
%exclude /var/lib/awx/venv
%defattr(-,root,root)
%doc %{_datadir}/doc/%{name}
%{_bindir}/awx-manage
%{_bindir}/awx-python
%{_bindir}/tower-manage
%{_bindir}/tower-python
%{_bindir}/automation-controller-service
%{_bindir}/failure-event-handler
/lib/systemd/system/automation-controller.service
%attr(2775,nginx,nginx) /var/run/tower
%dir %attr(0755,awx,awx) /var/lib/awx
%dir %attr(0755,awx,awx) /var/lib/awx/rsyslog
%attr(0750,awx,awx) /var/log/tower
/var/lib/awx/[^j]*
%attr(0750,awx,awx) /var/lib/awx/rsyslog/rsyslog.conf
%attr(0750,awx,awx) /var/lib/awx/job_status
%{_datadir}/awx/
%{_datadir}/sosreport/sos/plugins/controller.py*
%config(noreplace) %attr(-,root,awx) %{_sysconfdir}/tower

%files ui
%defattr(-,root,root)
/var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages/awx/static

%files venv-tower
%exclude /var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages/awx/static
%exclude /var/lib/awx/venv/awx/lib/python%{python3_version}/site-packages/awx/ui/static
%defattr(-,root,root)
/var/lib/awx/venv/awx

%files cli
%exclude /usr/bin/akit
%{_bindir}/awx
%{python3_sitelib}/awxkit*

%changelog
* Tue Sep 26 2023 Satoe Imaishi <simaishi@redhat.com> - 4.4.5-1
- Update to 4.4.5

* Tue Sep 12 2023 Satoe Imaishi <simaishi@redhat.com> - 4.4.4-1
- Update to 4.4.4

* Tue Aug 29 2023 Satoe Imaishi <simaishi@redhat.com> - 4.4.3-1
- Update to 4.4.3
- Fixes CVE-2023-23931 (cryptography: memory corruption via immutable objects)
- Fixes CVE-2023-40267 (GitPython: Insecure non-multi options in clone and
  clone_from is not blocked)

* Tue Aug 15 2023 Satoe Imaishi <simaishi@redhat.com> - 4.4.2-1
- Update to 4.4.2
- Fixes CVE-2023-24580 (Django: Potential denial-of-service vulnerability in
  file uploads)
- Fixes CVE-2023-36053 (Django: Potential regular expression denial of service
  vulnerability in EmailValidator/URLValidator)

* Thu Jul 27 2023 Satoe Imaishi <simaishi@redhat.com> - 4.4.1-1
- Update to 4.4.1
- Fixes CVE-2023-3971 (Html injection in custom login info)

* Mon Jun 12 2023 Satoe Imaishi <simaishi@redhat.com> - 4.4.0-1
- Automation Controller 4.4.0 release

* Tue Apr 04 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.8-1
- Automation Controller 4.3.8 release

* Thu Mar 23 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.7-1
- Automation Controller 4.3.7 release

* Mon Mar 06 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.6-1
- Automation Controller 4.3.6 release

* Wed Feb 01 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.5-1
- Automation Controller 4.3.5 release

* Tue Jan 10 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.4-1
- Automation Controller 4.3.4 release

* Thu Jan 05 2023 Satoe Imaishi <simaishi@redhat.com> - 4.3.3-1
- Automation Controller 4.3.3 release

* Wed Dec 14 2022 Satoe Imaishi <simaishi@redhat.com> - 4.3.2-1
- Automation Controller 4.3.2 release

* Wed Dec 07 2022 Satoe Imaishi <simaishi@redhat.com> - 4.3.1-1
- Automation Controller 4.3.1 release

* Fri Nov 11 2022 Satoe Imaishi <simaishi@redhat.com> - 4.3.0-2
- Automation Controller 4.3.0 release

* Tue Aug 30 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.1-1
- Automation Controller 4.2.1 release

* Wed Jul 20 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.0-6
- Add python3-libsemanage as a dependency

* Wed Jul 13 2022 Dimitri Savineau <dsavinea@redhat.com> - 4.2.0-5
- systemd: add dependency on receptor.service

* Mon Jun 27 2022 Hao Liu <haoli@redhat.com> - 4.2.0-4
- Update Ansible Runner version to 2.2.1

* Mon Jun 13 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.0-3
- Enable Korean locale

* Wed May 18 2022 Satoe Imaishi <simaishi@redhat.com> - 4.2.0-2
- Automation Controller 4.2.0 release
